﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;
using Microsoft.Phone.Controls;
using System.Windows.Media.Imaging;
using System.Xml.Linq;

namespace GetMeteo
{
    public partial class MainPage : PhoneApplicationPage
    {
        // Constructeur
        public MainPage()
        {
            InitializeComponent();
        }

        private const string key = "5fb4XXXXXXXXXXXXXXX110";

        private void button1_Click(object sender, RoutedEventArgs e)
        {
            try
            {
                if (string.IsNullOrEmpty(ville.Text))
                {
                    errorTb.Text = "Merci de saisir une ville";
                    return;
                }
                string paysStr = string.Empty;
                if (!string.IsNullOrEmpty(pays.Text))
                    paysStr = "," + pays.Text;
                var helper = new WebClientHelper(string.Format("http://www.worldweatheronline.com/feed/weather.ashx?q={0}{1}&format=xml&num_of_days=5&key={2}", ville.Text, paysStr, key));
                helper.DownloadComplete += DonwloadComplete;
                helper.Execute();
            }
            catch (Exception ex)
            {
                errorTb.Text = ex.Message;
            }
        }

        private void DonwloadComplete(object sender, DownloadStringCompletedEventArgs e)
        {
            if (e.Error != null)
            {
                errorTb.Text = e.Error.Message;
            }
            else
            {
                XDocument xmlElements = XDocument.Parse(e.Result);
                var request = from data in xmlElements.Descendants("request")
                              select new
                              {
                                  Query = (string)data.Element("query"),
                              };
                var elements = from data in xmlElements.Descendants("weather")
                               select new
                               {
                                   Date = (string)data.Element("date"),
                                   TemperatureMin = ((string)data.Element("tempMinC")).Trim(),
                                   TemperatureMax = ((string)data.Element("tempMaxC")).Trim(),
                                   UrlIcon = ((string)data.Element("weatherIconUrl")).Trim(),
                                   Temps = ((string)data.Element("weatherDesc")).Trim(),
                               };

                pivotCtrl.ItemsSource = elements.OrderBy(elt => elt.Date).Select(elt => new Meteo
                {
                    Date = elt.Date,
                    Emplacement = request.FirstOrDefault().Query,
                    TemperatureMax = "Température max : " + elt.TemperatureMax,
                    TemperatureMin = "Température min : " + elt.TemperatureMin,
                    Temps = Translate(elt.Temps),
                    UrlIcon = elt.UrlIcon
                });
            }
        }

        private string Translate(string s)
        {
            switch (s)
            {
                case "Partly Cloudy":
                    return "Partiellement nuageux";
                case "Sunny":
                    return "Soleil";
                case "Cloudy":
                    return "Nuageux";
                case "Light rain":
                    return "Faible pluie";
                case "Light rain shower":
                case "Light drizzle":
                case "Patchy light drizzle":
                case "Patchy light rain":
                    return "Bruine légère";
                case "Moderate rain":
                    return "Pluie modérée";
                case "Overcast":
                    return "Couvert";
                case "Patchy light rain in area with thunder":
                    return "Faible pluie et orages";
                default:
                    return s;
            }
        }
    }
}