﻿using System;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Ink;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;

namespace GetMeteo
{
    public class WebClientHelper
    {
        public event DownloadStringCompletedEventHandler DownloadComplete;
        private void OnDownloadComplete(object sender, DownloadStringCompletedEventArgs e)
        {
            if (DownloadComplete != null)
            {
                DownloadComplete(sender, e);
            }
        }

        private readonly string _url;

        public WebClientHelper(string url)
        {
            var random = new Random();
            _url = url;
            if (_url.Contains("?"))
                _url = _url + "&trick=" + random.Next();
            else
                _url = _url + "?trick=" + random.Next();
        }

        public void Execute()
        {
            var webClient = new WebClient();
            webClient.DownloadStringCompleted += webClient_DownloadStringCompleted;
            webClient.DownloadStringAsync(new Uri(_url));
        }

        void webClient_DownloadStringCompleted(object sender, DownloadStringCompletedEventArgs e)
        {
            if (e.Error == null)
            {
                OnDownloadComplete(sender, e);
            }
        }
    }
}
